/*
 * EntityManager Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;

   public class EntityManager extends Object {
   		// static stuff...
      static int shift = Entity.shift;
   
      static int temp_detection_distance;
      static int temp_detection_distance_squared;
   
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
      static int agent_counter;
      static int temp_direction;
      static int temp_count;
   
      static int tadx;
      static int tady;
      static int t2adx;
      static int t2ady;
   
      static int gcd;
      static int piston = 1000;
   
      static int new_bin_x;
      static int new_bin_y;
   
      static EntityList list;
   
      static int temp_x, temp_y, temp_radius;
   
      static Entity[] agent;
      static Entity[] new_array_of_agents;
      static Entity_Leader[] new_array_of_leaders;
      static Entity_Leader[] leader;
   
      static EntityGrid entity_grid;
   
      static Entity temp_agent;
      static Entity temp2_agent;
      static Entity_Leader temp_leader;
   
      static int target_number_of_agents = 600;
      static int number_of_agents     = 600;
      static int target_number_of_leaders = 1;
      static int number_of_leaders    = 1;
   
      static int towards_leader = 0x00 << shift;
      static int acc_of_leader = 0x00;
      static int gravity = 00;
   
      static int general_eggsize = 30;
      static int general_size = 14;
   
   
      static int number_of_ship;
   
      static int xoffset = 0;
      static int yoffset = 0;
   
      // static int number_of_ships = TRIG_TAB_SIZE;
   
      static Ships ship;
   
      // static int direction_bias = 0;
   
      EntityManager() {
      }
   
   
      final public static void initial() {
         number_of_agents = 1;
         number_of_leaders = 1;
      
         Entity.initial();
      
         agent = new Entity[number_of_agents];
      
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp] = new Entity(rnd.nextInt(Shoals_Canvas.gsx) << shift,rnd.nextInt(Shoals_Canvas.gsy) << shift, rnd.nextInt());
         }
      
         leader = new Entity_Leader[number_of_leaders];
      
         for (temp = 0; temp < number_of_leaders; temp++) {
            leader[temp] = new Entity_Leader(rnd.nextInt(Shoals_Canvas.gsx) << shift,rnd.nextInt(Shoals_Canvas.gsy) << shift, rnd.nextInt());
         }
      
         changeNumber();
      
         changeLeaderNumber();
      
         //resetEntityGrid(); // 
      }
   
   
     // called on resize...
      final public static void resetEntityGrid() {
         gcd = (general_eggsize + general_size + 4) << shift;
      
         temp = 12;
      
         while (gcd > (1 << temp)) {
            temp++;
         }
      
         entity_grid = new EntityGrid(temp);
      
         ensureEntitiesAreBinnedAgain();
      }
   
   
      final public static void ensureEntitiesAreBinnedAgain() {
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].current_bin_x = -1;
            agent[temp].current_bin_y = -1;
         }
      
         for (temp = 0; temp < number_of_leaders; temp++) {
            leader[temp].current_bin_x = -1;
            leader[temp].current_bin_y = -1;
         }
      }
   
   
      final static public void bufferedAgentUpdate() {
         if (number_of_leaders > 0) {
            scrubTheLeaders();
            travelTheLeaders();
         }
      
         if (number_of_agents > 0) {
            scrubTheAgents();
            travelTheAgents();
         }
      
         if (number_of_leaders > 0) {
            drawTheLeaders();
         }
      
         if (number_of_agents > 0) {
            drawTheAgents();
         }
      
         apply_acceleration();
         if (Shoals.check_collisions) {
            collisionCheck();
         }
      }
   
   
      final static public void unbufferedAgentUpdate() {
         if (Shoals.frame_frequency == 0) {
            if (number_of_agents > 0) {
               for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
                  Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
                  agent[agent_counter].scrub();
               
               
                  agent[agent_counter].travel();
               
                  Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
                  agent[agent_counter].draw();
               }
            }
         
            if (number_of_leaders > 0) {
               for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
                  Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
                  leader[agent_counter].scrub();
               
                  leader[agent_counter].travel();
               
                  Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
                  leader[agent_counter].draw();
               }
            }
         
            apply_acceleration();
            if (Shoals.check_collisions) {
               collisionCheck();
            }
         }
         else
         {
         
            if (number_of_agents > 0) {
               scrubTheAgents();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (number_of_agents > 0) {
                  travelTheAgents();
               }
            
               apply_acceleration();
               if (Shoals.check_collisions) {
                  collisionCheck();
               }
            }
         
            if (number_of_agents > 0) {
               drawTheAgents();
            }
         
            if (number_of_leaders > 0) {
               scrubTheLeaders();
            }
         
            for (temp = 0; temp <= Shoals.frame_frequency; temp++) {
               if (number_of_leaders > 0) {
                  travelTheLeaders();
               }
            
               if (Shoals.check_collisions) {
                  collisionCheck();
               }
            }
         
            if (number_of_leaders > 0) {
               drawTheLeaders();
            }
         
         }
      
      }
   
   
      final static public void collisionCheckXX() {
         // findNewBins();
      
         for (temp = 0; temp < (number_of_agents + number_of_leaders - 1); temp++) {
            setUpTempAgent();
            for (temp2 = temp + 1; temp2 < (number_of_agents + number_of_leaders); temp2++) {
               setUpTemp2Agent();
               collideTheseEntities();
            }
         }
      }
   
   
      final static public void collisionCheck() {
         // tinq++;
         if (Shoals.oscd) {
            collisionCheckXX();
         }
         else
         {
            findNewBins();
         
            for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
               setUpTempAgent();
            
               new_bin_x = temp_agent.current_bin_x; //temp_agent.x >>> EntityGrid.log2binsize;
               new_bin_y = temp_agent.current_bin_y; //temp_agent.y >>> EntityGrid.log2binsize;
            
               // C
               list = entity_grid.entity_list[new_bin_x][new_bin_y];
               temp3 = list.getNumberInList(temp_agent) + 1;
               if (temp3 < list.current_number) {
                  for (temp2 = temp3; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                  
                     collideTheseEntities();
                  }
               }
            
               // W
               if (new_bin_x > 0) {
                  list = entity_grid.entity_list[new_bin_x - 1][new_bin_y];
                  for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                     collideTheseEntities();
                  }
               
                  if (new_bin_y > 0) {
                     list = entity_grid.entity_list[new_bin_x - 1][new_bin_y - 1];
                     for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                        temp2_agent = list.entity[temp2];
                        collideTheseEntities();
                     }
                  }
               }
            
               // U
               if (new_bin_y > 0) {
                  list = entity_grid.entity_list[new_bin_x][new_bin_y - 1];
                  for (temp2 = 0; temp2 < (list.current_number); temp2++) {
                     temp2_agent = list.entity[temp2];
                     collideTheseEntities();
                  }
               }
            
            }
         }
      }
   
   
      final static public void setUpTempAgent() {
         if (temp < number_of_agents) {
            temp_agent = agent[temp];
         }
         else
         {
            temp_agent = leader[temp - number_of_agents];
         }
      }
   
   
      final static public void setUpTemp2Agent() {
         if (temp2 < number_of_agents) {
            temp2_agent = agent[temp2];
         }
         else
         {
            temp2_agent = leader[temp2 - number_of_agents];
         }
      
      }
   
      final static public void findNewBins() {
         for (temp = 0; temp < (number_of_agents + number_of_leaders); temp++) {
         
            setUpTempAgent();
         
            new_bin_x = temp_agent.x >>> EntityGrid.log2binsize;
            new_bin_y = temp_agent.y >>> EntityGrid.log2binsize;
         
            if ((temp_agent.current_bin_x != new_bin_x) || (temp_agent.current_bin_y != new_bin_y)) {
               EntityGrid.addToList(new_bin_x, new_bin_y, temp_agent);
               EntityGrid.removeFromList(temp_agent.current_bin_x, temp_agent.current_bin_y, temp_agent);
            
               temp_agent.current_bin_x = new_bin_x;
               temp_agent.current_bin_y = new_bin_y;
            }
         }
      }
   
   
      boolean sameSign(int a, int b) {
         return (((a ^ b) & 0x80000000) == 0);
      }
   
   
      final static public void apply_acceleration() {
         // apply acceleration...
         if (number_of_agents > 0) {
            // if (number_of_leaders > 0) {
            for (temp = 0; temp < number_of_agents; temp++) {
               temp_agent = agent[temp];
            
                     // turn about...
            
               /*
                  for (temp2 = 0; temp2 < number_of_leaders; temp2++) {
                     temp4 = temp_agent.x - leader[temp2].x;
                  temp5 = temp_agent.y - leader[temp2].y;
                  
                     if ((temp4 < 0) && (temp5 < 0)) {
                        temp3 = rnd.nextInt();
                        if (temp4 < temp5) {
                           temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + Entity.direction_bias;
                        }
                        else
                        {
                           temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 4 + Entity.direction_bias;
                        }
                     }
                     else
                     {
                        if ((temp4 < 0) && (temp5 >= 0)) {
                           temp3 = rnd.nextInt();
                           if (-temp4 < temp5) {
                              temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 24 + Entity.direction_bias;
                           }
                           else
                           {
                              temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 28 + Entity.direction_bias;
                           }
                        }
                        else
                        {
                           if ((temp4 >= 0) && (temp5 < 0)) {
                              temp3 = rnd.nextInt();
                              if (temp4 < -temp5) {
                                 temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 8 + Entity.direction_bias;
                              }
                              else
                              {
                                 temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 12 + Entity.direction_bias;
                              }
                           }
                           else
                           {
                              if ((temp4 > 0) && (temp5 >= 0)) {
                                 temp3 = rnd.nextInt();
                                 if (temp4 > temp5) {
                                    temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 16 + Entity.direction_bias;
                                 }
                                 else
                                 {
                                    temp_agent.preferred_direction = (temp3 & 3) + (temp3 >>> 31) + 20 + Entity.direction_bias;
                                 }
                              }
                           }
                        }
                     }
                  
                  // conditional...
                  
                     temp_agent.thrust(towards_leader);
                  }
               	*/
               temp_agent.dy += gravity;
            }
         }
      
      /*
         // apply acceleration to leader...
         if (number_of_leaders > 0) {
            for (temp2 = 0; temp2 < number_of_leaders; temp2++) {
               if (leader[temp2].x < (Shoals_Canvas.current_mouse_x << Entity.shift)) {
                  leader[temp2].dx += acc_of_leader; // Entity.towards_leader;
               }
               else
               {
                  leader[temp2].dx -= acc_of_leader; // Entity.towards_leader;
               }
            
               if (leader[temp2].y < (Shoals_Canvas.current_mouse_y << Entity.shift)) {
                  leader[temp2].dy += acc_of_leader; // Entity.towards_leader;
               }
               else
               {
                  leader[temp2].dy -= acc_of_leader; // Entity.towards_leader; // acc_of_leader;
               }
            
               leader[temp2].dy += gravity;
            }
         }
      */
      }
   
   
   // accepts temp_agent and temp2_agent
      final static public void collideTheseEntities() {
         temp_detection_distance = temp_agent.detection_radius + temp2_agent.detection_radius;
         temp3 = temp_agent.x - temp2_agent.x;
         temp5 = (temp3 < 0) ? -temp3 : temp3;
         if (temp5 < temp_detection_distance) {
            temp4 = temp_agent.y - temp2_agent.y;
            temp6 = (temp4 < 0) ? -temp4 : temp4;
            if (temp6 < temp_detection_distance) {
               // probable collision...
               // make smaller to prevent overflow...
               tadx = (temp5 >> shift);
               tady = (temp6 >> shift);
               temp_radius = (tadx * tadx) + (tady * tady); // now check using circle...
               temp_detection_distance_squared = temp_detection_distance >> shift;
               temp_detection_distance_squared *= temp_detection_distance_squared; // temp_detection_distance * temp_detection_distance;
               if (temp_radius < temp_detection_distance_squared) {
                        // collision 
                  temp_radius = (int)Math.sqrt(temp_radius);
                  if (temp_radius < 1) {
                     temp_radius = 1;
                  }
               
                  // find unit vector along collision path...
                  temp_x = (temp3) / temp_radius; // unit vector * 65536
                  temp_y = (temp4) / temp_radius;
               
                        // debug("temp_x:" + temp_x + " - temp_y:" + temp_y); // seems ok
               
                        // compute the relative velocities...
               
                        //tadx = temp_agent.dx - temp2_agent.dx;
                        //tady = temp_agent.dy - temp2_agent.dy;
               
                        //if (((tadx * temp3) + (tady * temp4)) > 0) {
               
                           //tadx = (tadx * temp_x) >> shift;
                           //tady = (tady * temp_y) >> shift;
               
                        //debug("ddx:" + tadx + " - Delta_x:" + temp3 + " - ddy:" + tady + " - Delta_y:" + temp4);
               
                        // debug("DD:" + temp_detection_distance);
               
                        // if (((tadx ^ temp3) < 0) && ((tady ^ temp4) < 0)) {
                        /*
                           temp_agent.dx += tadx;
                           temp_agent.dy += tady;
                           temp2_agent.dx -= tadx;
                           temp2_agent.dy -= tady; */
               
                        // crude hack - since impulse calculations don't seem to be running yet...
               
                  temp_agent.dx += temp_x << 3;
                  temp_agent.dy += temp_y << 3;
                  temp2_agent.dx -= temp_x << 3;
                  temp2_agent.dy -= temp_y << 3;
               
                        //}
                        // }
                        /*else
                        {
                           temp_agent.dx += temp_x << 2;
                           temp_agent.dy += temp_y << 2;
                           temp2_agent.dx -= temp_x << 2;
                           temp2_agent.dy -= temp_y << 2;
                        }*/
               
                           /*
                           if (tadx == 0) {
                           tadx = 1 << shift;
                           }
                           
                           if (tadx == 0) {
                           tadx = 1 << shift;
                           } */
                           /*
                           temp_count = 12;
                           
                           do {
                           temp_agent.x += (tadx >> 4);
                           temp_agent.y += (tady >> 4);
                           temp2_agent.x -= (tadx >> 4);
                           temp2_agent.y -= (tady >> 4);
                           
                           temp3 = temp_agent.x - temp2_agent.x;
                           temp5 = (temp3 < 0) ? -temp3 : temp3;
                           
                           temp4 = temp_agent.y - temp2_agent.y;
                           temp6 = (temp4 < 0) ? -temp4 : temp4;
                           
                           temp_radius = (temp5 * temp5) + (temp6 * temp6);  // now check using circle...
                           } while ((temp_radius < detection_radius_squared) && (temp_count-- > 0));
                           */
               
                           /*
                           temp_agent.x += temp_agent.dx;
                           temp_agent.y += temp_agent.dy;
                           temp2_agent.x += temp2_agent.dx;
                           temp2_agent.y += temp2_agent.dy;
                           */
               
               }
            }
         }
      }
   
   
      final static void drawTheAgents() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
            agent[agent_counter].draw();
         }
      }
   
   
      final static void scrubTheAgents() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
            agent[agent_counter].scrub();
         }
      }
   
   
      final static void travelTheAgents() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         for (agent_counter = 0; agent_counter < number_of_agents; agent_counter++) {
            agent[agent_counter].travel();
         }
      }
   
   
      final static void drawTheLeaders() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].draw();
         }
      }
   
   
      final static void travelTheLeaders() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].travel();
         }
      }
   
   
      final static void scrubTheLeaders() {
         Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].scrub();
         }
      }
   
   
      public static void setGlobalSize(int d) {
         general_size = d;
      
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].setSize(d);
         }
      
         for (temp = 0; temp < Entity.TRIG_TAB_SIZE; temp++) {
            Entity.ship_image_array[temp] = null;
         }
      
      }
   
   
      public static void setGlobalEggSize(int d) {
         general_eggsize = d;
      
         for (agent_counter = 0; agent_counter < number_of_leaders; agent_counter++) {
            leader[agent_counter].setSize(d);
         }
      
         Entity.ring_image = null;
      }
   
   
      final static void changeNumber() {
         if ((target_number_of_agents != number_of_agents)) {
            while (target_number_of_agents > number_of_agents) {
               addNewEntity();
            }
         
            while (target_number_of_agents < number_of_agents) {
               killEntity(0);
            }
         
            resetEntityGrid();
         }
      }
   
   
      final static void changeLeaderNumber() {
         if ((target_number_of_leaders != number_of_leaders)) {
            while (target_number_of_leaders > number_of_leaders) {
               addNewLeaderEntity();
            }
         
            while (target_number_of_leaders < number_of_leaders) {
               killLeaderEntity(0);
            }
         
            resetEntityGrid();
         }
      }
   
   
      // wastes memory, but who cares?
      final static void addNewEntity() {
         number_of_agents++;
      
         new_array_of_agents = new Entity[number_of_agents];
      
         for (temp = 0; temp < (number_of_agents - 1); temp++) {
            new_array_of_agents[temp] = agent[temp];
         }
      
         if (number_of_agents > 1) {
            temp = rnd.nextInt(number_of_agents - 1);
            temp_x = agent[temp].x;
            temp_y = agent[temp].y;
         }
         else
         {
            temp_x = rnd.nextInt(Shoals_Canvas.gsx) << shift;
            temp_y = rnd.nextInt(Shoals_Canvas.gsy) << shift;
         }
      
         new_array_of_agents[number_of_agents - 1] = new Entity(temp_x, temp_y, rnd.nextInt());
      
         agent = new_array_of_agents;
      }
   
   
      // wastes memory, but who cares?
      final static void addNewLeaderEntity() {
         number_of_leaders++;
      
         new_array_of_leaders = new Entity_Leader[number_of_leaders];
      
         for (temp = 0; temp < (number_of_leaders - 1); temp++) {
            new_array_of_leaders[temp] = leader[temp];
         }
      
         if (number_of_leaders > 1) {
            temp = rnd.nextInt(number_of_leaders - 1);
            temp_x = leader[temp].x;
            temp_y = leader[temp].y;
         }
         else
         {
            temp_x = rnd.nextInt(Shoals_Canvas.gsx) << shift;
            temp_y = rnd.nextInt(Shoals_Canvas.gsy) << shift;
         }
      
         new_array_of_leaders[number_of_leaders - 1] = new Entity_Leader(temp_x, temp_y, rnd.nextInt());
      
         leader = new_array_of_leaders;
      }
   
   
      final static void killEntity(int n) {
         number_of_agents--;
      }
   
   
      final static void killLeaderEntity(int n) {
      
         number_of_leaders--;
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
