//
// Ships.java
//

   import java.lang.Object;
   import java.applet.*;
   import java.awt.*;
   import java.awt.Component;
   import java.awt.event.*;
   import java.awt.image.*;
   import java.io.*;
   import java.util.*;

   public class Ships extends Panel {
      int O,W,S,OT,OTU,OP; // pixel coordinates
      int D;
   // O=offset, W=total width, D=field width, S=board size (9,11,13,19)
   // OT=offset for coordinates to the right and below
   // OTU=offset above the board and below for coordinates
      int lasti=-1,lastj=0; // last move (used to highlight the move)
      boolean showlast; // internal flag, if last move is to be highlighted
      Image Empty,EmptyShadow,ActiveImage;
   	// offscreen images of empty and current board
      // Position P; // current board position
      int number; // number of the next move
      int State; // states: 1 is black, 2 is white, 3 is set black etc.
   	// see GoFrame.setState(int)
      Font font; // Font for board letters and coordinates
      FontMetrics fontmetrics; // metrics of this font
      boolean Active;
      int MainColor=1;
      public int MyColor=0;
      int sendi=-1,sendj;
   	// board position which has been sended to server
      Dimension Dim; // Note size to check for resizeing at paint
      String TextMarker="A";
      public int Pw,Pb; // Prisoners (white and black)
      public Image ship_shadow, ship_black, ship_white;
      int Range=-1; // Numbers display from this one
      boolean KeepRange=false;
      String NodeName="",LText="";
      boolean DisplayNodeName=false;
      public boolean Removing=false;
      boolean Activated=false;
      public boolean Teaching=false; // enable teaching mode
      public int aa_col = 0xF0C8C0; // GF.boardColor().getRGB();
   
      static JUR rnd = new JUR();
   
      double ship_clam_angle;
      double ship_clam_angle_x;
      double ship_clam_angle_y;
   
      int    ship_clam_spacing;
      int    ship_clam_intensity = 48;
   
      int    ship_slate_spacing;
      int    ship_slate_intensity = 11;
   
      int    ship_size;
   
      double non_linear_c1;
      double non_linear_c2;
      double non_linear_c3;
      double non_linear_c4;
   
      double non_linear_s1;
      double non_linear_s2;
      double non_linear_s3;
      double non_linear_s4;
   
      double non_linear_effect_size;
   
      double x, y, z, xr, xgc, xgs, hh;
      int i, j, g, k;
      static int t, t2, temp;
   
      public int ship_type = 7;
      public int no_clamshell = 0;
      public double pixel  = 0.9;
      public double shadow = 0.7;
      public int depression = 0;
      public int darkness = 0;
   
      final static int TYPE_WHITE  = 1;
      final static int TYPE_BLACK  = 2;
      final static int TYPE_SHADOW = 4;
   
      static int TRIG_TAB_SIZE = 32;
      static int TRIG_TAB_SIZEMO = TRIG_TAB_SIZE - 1;
      static int[] sin_tab;
      static int[] cos_tab;
   
      static int lut_shift = 8;
      static int lut_magnitude = 1 << lut_shift;
   
      static int eye_dir;
      static int eye_x;
      static int eye_y;
      static int eye_radius;
      static int eye_radius2;
   
      static int eye_limit1;
      static int eye_limit2;
      static int eye_limit3;
   
   
      final public static void initial() {
      
         sin_tab = new int[TRIG_TAB_SIZE];
         cos_tab = new int[TRIG_TAB_SIZE];
         for (temp = 0; temp < TRIG_TAB_SIZE; temp++) {
            sin_tab[temp] = (int)(lut_magnitude * (java.lang.Math.sin((temp * 2 * java.lang.Math.PI) / (double)TRIG_TAB_SIZE)));
            cos_tab[temp] = (int)(lut_magnitude * (java.lang.Math.cos((temp * 2 * java.lang.Math.PI) / (double)TRIG_TAB_SIZE)));
         }
      }
   
   
      public void generateBlackShip(int ss) {
      // Create the images of the ships (black)
      
         int blue =  aa_col&0x0000FF;
         int green= (aa_col&0x00FF00)>>8;
         int red  = (aa_col&0xFF0000)>>16;
      
         ship_size = ss;
      
         ship_clam_angle = (rnd.nextInt() % 512) * 3.14 / 512.0 + (3 * 3.14 / 4.0);
         ship_clam_angle_x = Math.sin(ship_clam_angle);
         ship_clam_angle_y = Math.cos(ship_clam_angle);
      
         ship_slate_spacing = ship_size / 10;
         if (ship_slate_spacing < 1)
            ship_slate_spacing = 1;
      
         non_linear_effect_size = 224 * ((double)ship_size);
      
         non_linear_s1 = (double)((rnd.nextInt() & 1023) / non_linear_effect_size);
         non_linear_s2 = (double)((rnd.nextInt() & 1023) / non_linear_effect_size);
         non_linear_s3 = (double)((rnd.nextInt() & 1023) / non_linear_effect_size);
         non_linear_s4 = (double)((rnd.nextInt() & 1023) / non_linear_effect_size);
      
         int d = ship_size + 2;
      
         int pb[]=new int[d * d];
         int pw[]=new int[d * d];
         int ps[]=new int[d * d];
      
      
         int t; // temp
         int gr, gg, gb;
         double di, dj;
         double d2 = (double)(d / 2.0 - 5e-1);
         double r = d2 - 2e-1;
         double f = Math.sqrt(3);
      
         k=0;
      
         for (i = 0; i < d; i++) {
            for (j = 0; j < d; j++)
            {	
               di = i - d2; 
               dj = j - d2;
               hh = r - Math.sqrt(di * di + dj * dj); // Multiply to alter aspect ratio...
               if (hh >= 0)
               {	
                  z = r * r - di * di - dj * dj;
                  if (z > 0)
                     z = Math.sqrt(z)*f;
                  else 
                     z = 0;
                  x = di;
                  y = dj;
                  xr = Math.sqrt(6 * (0.88 * x * x + 0.88 * y * y + z * z)); // small z multiplier = high intensity highlight...
               
                  if (depression == 0) {
                     xr = (2 * z - x - y) / xr;
                  }
                  else
                  {
                     if (darkness == 0) {
                        xr = (1.85 * z + x + y) / xr;
                     }
                     else
                     {
                        xr = 0;
                     }
                  }
               
                  // black...
                  if (xr > 0.89) 
                     xgs = (xr - 0.89) * (xr - 0.89) * 60;
                  else 
                     xgs = 0;
               
                  if (hh > pixel)
                  {
                     g = slateAdjustments();
                  
                     pb[k] = (255 << 24) | (g << 16) | (g << 8) | g;
                  }
                  else
                  {	
                     hh = (pixel - hh) / pixel;
                  
                     double shade;
                     if ((dj + di) < (r / 3)) 
                        shade = 1;
                     else 
                        shade = shadow;
                  
                     g = slateAdjustments();
                     pb[k] = ((255 << 24)
                             | (((int)((1-hh)*g+hh*shade*red  ))<<16)
                             | (((int)((1-hh)*g+hh*shade*green))<<8 )
                             |  ((int)((1-hh)*g+hh*shade*blue ))    );
                  
                  }
               }
               else 
                  pb[k] = 0; // transparent colour...
               k++;
            }
         }
      
         ship_black  = createImage(new MemoryImageSource(d,d,ColorModel.getRGBdefault(),pb,0,d));
      }
   
   
      public void generateShip(int ss, int direction) {
      // Create the images of the ships (black and white)
      
         ship_clam_angle = ((direction + 8) * 2 * java.lang.Math.PI) / 32;
      
         int blue =  aa_col&0x0000FF;
         int green= (aa_col&0x00FF00)>>8;
         int red  = (aa_col&0xFF0000)>>16;
      
         ship_size = ss;
      
         // ship_clam_angle = (rnd.nextInt() % 512) * 3.14 / 512.0 + (3 * 3.14 / 4.0);
         ship_clam_angle_x = Math.sin(ship_clam_angle);
         ship_clam_angle_y = Math.cos(ship_clam_angle);
      
         ship_clam_spacing = ship_size / 8;
         if (ship_clam_spacing < 6) 
            ship_clam_spacing = 6;
      
         non_linear_effect_size = 1280 * ((double)ship_size);
      
         non_linear_c1 = (double)((rnd.nextInt() & 127) / non_linear_effect_size);
         non_linear_c2 = (double)((rnd.nextInt() & 511) / non_linear_effect_size);
         non_linear_c3 = (double)((rnd.nextInt() & 127) / non_linear_effect_size);
         non_linear_c4 = (double)((rnd.nextInt() & 511) / non_linear_effect_size);
      
         int d = ship_size + 2;
      
         int pw[]=new int[d * d];
      
         int t; // temp
         int gr, gg, gb;
         double di, dj;
         double d2 = (double)(d / 2.0 - 5e-1); // r = d / 2
         double r = d2 - 2e-1;
         double f = Math.sqrt(3);
      
         k=0;
      
         for (i = 0; i < d; i++) {
            for (j = 0; j < d; j++)
            {	
               di = i - d2; 
               dj = j - d2;
               hh = r - Math.sqrt(di * di + dj * dj); // Multiply to alter aspect ratio...
               if (hh >= 0)
               {
                  z = r * r - di * di - dj * dj;
                  if (z > 0)
                     z = Math.sqrt(z)*f;
                  else 
                     z = 0;
                  x = di;
                  y = dj;
                  xr = Math.sqrt(6 * (0.88 * x * x + 0.88 * y * y + z * z)); // small z multiplier = high intensity highlight...
               
                  if (depression == 0) {
                     xr = (2 * z - x - y) / xr;
                  }
                  else
                  {
                     if (darkness == 0) {
                        xr = (1.85 * z + x + y) / xr;
                     }
                     else
                     {
                        xr = 0;
                     }
                  }
               
                  // white (non-phong? remove square...)
                  if (xr > 0.75) 
                     xgc = (xr - 0.75) * 2;
                  else 
                     xgc = 0;
               
                  // black...
                  if (xr > 0.89) 
                     xgs = (xr - 0.89) * (xr - 0.89) * 60;
                  else 
                     xgs = 0;
               
                  if (hh > pixel)
                  {
                     g = clamAdjustments();
                  
                     pw[k] = (255 << 24)|(g << 16)|(g << 8)|g;
                  }
                  else
                  {	
                     hh = (pixel - hh) / pixel;
                  
                     double shade;
                     if ((dj + di) < (r / 3)) 
                        shade = 1;
                     else 
                        shade = shadow;
                  
                     g = clamAdjustments();
                  
                     pw[k] = ((255 << 24)
                             | (((int)((1-hh)*g+hh*shade*red  )) << 16)
                             | (((int)((1-hh)*g+hh*shade*green)) << 8)
                             |  ((int)((1-hh)*g+hh*shade*blue ))     );
                  }
               }
               else 
                  pw[k] = 0; // transparent colour...
            /*
               eye_radius = (int)((d2 * 2) / 3);
               eye_dir = (direction + (TRIG_TAB_SIZE >>> 3)) & TRIG_TAB_SIZEMO;
            
               eye_x = (int)(d2 + 1 + ((sin_tab[eye_dir] * eye_radius) >> lut_shift));
               eye_y = (int)(d2 + 1 + ((cos_tab[eye_dir] * eye_radius) >> lut_shift));
               eye_limit1 = (ship_size * ship_size) / 60;
               eye_limit2 = (ship_size * ship_size) / 40;
               eye_limit3 = (ship_size * ship_size) / 20;
            
               t2 = ((i-eye_x) * (i-eye_x)) + ((j-eye_y) * (j-eye_y));
            
               if (t2 < eye_limit1) {
                  pw[k] = 0xffff2020;
               }
               else
               {
                  if (t2 < eye_limit2) {
                     pw[k] = betweenColours(0xff2020,0x010101,((t2 - eye_limit1) * 100) / (eye_limit2 - eye_limit1));
                  }
                  else
                  {
                     if (t2 < eye_limit3) {
                        pw[k] = betweenColours(0x010101,pw[k],((t2 - eye_limit2) * 100) / (eye_limit3 - eye_limit2));
                     }
                  }
               }
            
               eye_dir = (direction - (TRIG_TAB_SIZE >>> 3)) & TRIG_TAB_SIZEMO;
            
               eye_x = (int)(d2 + 1 +((sin_tab[eye_dir] * eye_radius) >> lut_shift));
               eye_y = (int)(d2 + 1 + ((cos_tab[eye_dir] * eye_radius) >> lut_shift));
               eye_limit1 = (ship_size * ship_size) / 60;
               eye_limit2 = (ship_size * ship_size) / 40;
               eye_limit3 = (ship_size * ship_size) / 20;
            
               t2 = ((i-eye_x) * (i-eye_x)) + ((j-eye_y) * (j-eye_y));
               if (t2 < eye_limit1) {
                  pw[k] = 0xffff2020;
               }
               else
               {
                  if (t2 < eye_limit2) {
                     pw[k] = betweenColours(0xff2020,0x010101,((t2 - eye_limit1) * 100) / (eye_limit2 - eye_limit1));
                  }
                  else
                  {
                     if (t2 < eye_limit3) {
                        pw[k] = betweenColours(0x010101,pw[k],((t2 - eye_limit2) * 100) / (eye_limit3 - eye_limit2));
                     }
                  }
               }
            	*/
            
               k++;
            }
         }
      
         ship_white  = createImage(new MemoryImageSource(d,d,ColorModel.getRGBdefault(),pw,0,d));
      }
   
   
   
      public void generateRing(int ss) {
      // Create the images of the ships (black and white)
      
         int blue =  aa_col&0x0000FF;
         int green= (aa_col&0x00FF00)>>8;
         int red  = (aa_col&0xFF0000)>>16;
      
         ship_size = ss;
      
         ship_clam_angle = 0;//(rnd.nextInt() % 512) * 3.14 / 512.0 + (3 * 3.14 / 4.0);
         ship_clam_angle_x = 0;//Math.sin(ship_clam_angle);
         ship_clam_angle_y = 0;//Math.cos(ship_clam_angle);
      
         ship_clam_spacing = 100;//ship_size / 8;
         if (ship_clam_spacing < 6) 
            ship_clam_spacing = 6;
      
         non_linear_effect_size = 0;//1280 * ((double)ship_size);
      
         non_linear_c1 = 0;//(double)((rnd.nextInt() & 1023) / non_linear_effect_size);
         non_linear_c2 = 0;//(double)((rnd.nextInt() & 1023) / non_linear_effect_size);
         non_linear_c3 = 0;//(double)((rnd.nextInt() & 1023) / non_linear_effect_size);
         non_linear_c4 = 0;//(double)((rnd.nextInt() & 1023) / non_linear_effect_size);
      
         int d = ship_size + 2;
      
         int pw[]=new int[d * d];
      
         int t; // temp
         int gr, gg, gb;
         double di, dj;
         double d2 = (double)(d / 2.0 - 5e-1); // r = d / 2
         double r = d2 - 2e-1;
         double f = Math.sqrt(3);
      
         k=0;
      
         for (i = 0; i < d; i++) {
            for (j = 0; j < d; j++) {	
               di = i - d2; 
               dj = j - d2;
               hh = r - Math.sqrt(di * di + dj * dj); // Multiply to alter aspect ratio...
               if (hh >= 0) {
                  z = r * r - di * di - dj * dj;
                  if (z > 0)
                     z = Math.sqrt(z)*f;
                  else 
                     z = 0;
                  x = di;
                  y = dj;
                  xr = Math.sqrt(6 * (0.88 * x * x + 0.88 * y * y + z * z)); // small z multiplier = high intensity highlight...
               
                  if (depression == 0) {
                     xr = (2 * z - x - y) / xr;
                  }
                  else
                  {
                     if (darkness == 0) {
                        xr = (1.85 * z + x + y) / xr;
                     }
                     else
                     {
                        xr = 0;
                     }
                  }
               
                  // white (non-phong? remove square...)
                  if (xr > 0.75) 
                     xgc = (xr - 0.75) * 2;
                  else 
                     xgc = 0;
               
                  // black...
                  if (xr > 0.89) 
                     xgs = (xr - 0.89) * (xr - 0.89) * 60;
                  else 
                     xgs = 0;
               
                  if (hh > pixel) {
                     g = clamAdjustments(); // slateAdjustments(); //clamAdjustments();
                  
                     pw[k] = (255 << 24)|(g << 16)|(g << 8)|g;
                  }
                  else
                  {
                     hh = (pixel - hh) / pixel;
                  
                     double shade;
                     if ((dj + di) < (r / 3)) 
                        shade = 1;
                     else 
                        shade = shadow;
                  
                     g = clamAdjustments(); // slateAdjustments(); //clamAdjustments();
                  
                     pw[k] = ((255 << 24)
                             | (((int)((1-hh)*g+hh*shade*red  )) << 16)
                             | (((int)((1-hh)*g+hh*shade*green)) << 8)
                             |  ((int)((1-hh)*g+hh*shade*blue ))     );
                  }
               }
               else 
                  pw[k] = 0; // transparent colour...
            
               eye_radius  = (int)((d2 * 48) / 64);
               eye_radius2 = (int)((d2 * 63) / 64);
            
               eye_limit1 = (eye_radius * eye_radius);
               eye_limit2 = (eye_radius2 * eye_radius2);
            
               eye_x = (int)(d2);
               eye_y = (int)(d2);
            
               t2 = ((i-eye_x) * (i-eye_x)) + ((j-eye_y) * (j-eye_y));
            
               if (t2 < (eye_limit1)) {
                  pw[k] = 0x00;
               }
               else
               {
                  if (t2 < eye_limit2) {
                     pw[k] = betweenColours(0x010101,pw[k],((t2 - eye_limit1) * 100) / (eye_limit2 - eye_limit1));
                  }
               }
            
               k++;
            }
         }
      
         ship_white  = createImage(new MemoryImageSource(d,d,ColorModel.getRGBdefault(),pw,0,d));
      }
   
   
      public int betweenColours(int c1, int c2, int percent) {
         int r1 = (c1 >>> 16) & 255;
         int r2 = (c2 >>> 16) & 255;
      
         int g1 = (c1 >>> 8) & 255;
         int g2 = (c2 >>> 8) & 255;
      
         int b1 = (c1) & 255;
         int b2 = (c2) & 255;
      
         r1 = r1 + (percent * (r2 - r1)) / 100;
         g1 = g1 + (percent * (g2 - g1)) / 100;
         b1 = b1 + (percent * (b2 - b1)) / 100;
      
         return 0xff000000 | (r1 << 16) | (g1 << 8) | b1;	
      }
   
   
      public void generateShipShadow(int ss) {
      // Create the images of the ships (black and white)
      
         int blue =  aa_col & 0x0000FF;
         int green= (aa_col & 0x00FF00)>>8;
         int red  = (aa_col & 0xFF0000)>>16;
      
         ship_size = ss;
      
         // D = ship_size;
      
         int d = ship_size + 2;
      
         int pb[]=new int[d * d];
         int pw[]=new int[d * d];
         int ps[]=new int[d * d];
      
         int t; // temp
         int gr, gg, gb;
         double di, dj;
         double d2 = (double)(d / 2.0 - 5e-1);
         double r = d2 - 2e-1;
         double f = Math.sqrt(3);
      
         k=0;
         for (i = 0; i < d; i++) {
            for (j = 0; j < d; j++)
            {	
               di = i - d2; 
               dj = j - d2;
               hh = r - Math.sqrt(di * di + dj * dj); // Multiply to alter aspect ratio...
               if (hh >= 0)
               {	
                  z = r * r - di * di - dj * dj;
                  if (z > 0)
                     z = Math.sqrt(z)*f;
                  else 
                     z = 0;
                  x = di;
                  y = dj;
                  xr = Math.sqrt(6 * (0.88 * x * x + 0.88 * y * y + z * z)); // small z multiplier = high intensity highlight...
               
                  if (depression == 0) {
                     xr = (2 * z - x - y) / xr;
                  }
                  else
                  {
                     if (darkness == 0) {
                        xr = (1.85 * z + x + y) / xr;
                     }
                     else
                     {
                        xr = 0;
                     }
                  }
               
                  if (hh > pixel)
                  {
                     gr = (int)(0x60);
                     gg = (int)(0x40);
                     gb = (int)(0x18);
                  
                        //if ((rnd.nextInt() & 255) > 64) {
                     ps[k]=(255 << 24) | (gr << 16) | (gg << 8) | gb;
                        //}
                        //else
                        //{
                          // ps[k] = 0;
                        //}
                  }
                  else
                  {	
                     hh = (pixel - hh) / pixel;
                  
                     double shade;
                     if ((dj + di) < (r / 3)) 
                        shade = 1;
                     else 
                        shade = shadow;
                  
                     gr = (int)(0x60);
                     gg = (int)(0x40);
                     gb = (int)(0x18);
                  
                     if ((hh < 0.5) || ((rnd.nextInt() & 255) > (128 * hh * hh * hh * hh * hh * hh))) {
                        ps[k]=((255 << 24)
                              | (((int)((1-hh)*gr+hh*shade*red  ))<<16)
                              | (((int)((1-hh)*gg+hh*shade*green))<< 8)
                              |  ((int)((1-hh)*gb+hh*shade*blue ))    );
                     }
                     else
                     {
                        ps[k] = 0;
                     }
                  
                  }
               }
               else 
                  ps[k] = 0; // transparent colour...
               k++;
            }
         }
      
         ship_shadow = createImage(new MemoryImageSource(d,d,ColorModel.getRGBdefault(),ps,0,d));
      
      }
   
   
   /* needs anti-aliasing... */
      private int clamAdjustments() {
         g = (int)(64 + 96 * xr + xgc * 96);
      
         if (no_clamshell != 0) 
            return g;
         t = 8000 + (int)(((((i * ship_clam_angle_x) + (j * ship_clam_angle_y) + ((j * j) * non_linear_c1) + ((i * i) * non_linear_c3) + ((i * j) * non_linear_c3) - ((i * j) * non_linear_c4)))) * ship_clam_intensity / ship_clam_spacing);
      
         t2 = t % (ship_clam_intensity);
         if (t2 <= (ship_clam_intensity / 8)) 
            t2 = ship_clam_intensity - t2 * 8;
         g += t2;
         if (g > 255)
            g = 255;
      
         if (g < 0) 
            g = 0;
         return g;
      }
   
   
      private int slateAdjustments() {
      	// first = ambient, 2nd = highlight...
         // g = (int)(10 + 10 * xr + xg * 40);
         g = (int)(10 * xr + xgs * 255);
      
         if (no_clamshell != 0)
            return g;
         t = 8000 + (int)(((((i * ship_clam_angle_x) + (j * ship_clam_angle_y) + ((j * j) * non_linear_s1) + ((i * i) * non_linear_s3) + ((i * i) * non_linear_s3) - ((i * j) * non_linear_s4))))) * ship_slate_intensity / ship_slate_spacing;
      
         t2 = t % (ship_slate_intensity);
      
         if (t2 < ship_slate_intensity / 2)
            t2 = 0;
      
         t = 8000 + (int)(((((j * ship_clam_angle_x) + (i * ship_clam_angle_y) + ((j * i) * non_linear_s1) + ((i * i) * non_linear_s3) + ((i * j) * non_linear_s3) - ((i * i) * non_linear_s4))))) * ship_slate_intensity / ship_slate_spacing;
      
         t2 = t2 + (t % (ship_slate_intensity)) / 2;
      
      
         g += t2;
      
         g += ((rnd.nextInt() & 1023) * 40 * xr) / 1024; // add some noise...
      
         if (g > 255)
            g = 255;
         if (g < 1) 
            g = 1;
      
         return g;
      }
   
   }
