/*
 * Shoals - Tim Tyler 1999-2000
 */

 /* To do
  * =====
  *
  * Click to kill...
  * Piston
  * Crystallistation model...
  * Swarm behaviour, using grids...
  * variable size egg...
  * Improved collisions...
  * Write associated game...
  * Explosive deaths...
  * "Starfish" - rods between cells...
  * Anti-aliased drawing library (DIY using blur?)...
  * 
  * Done
  * ====
  * 
  * Collisions...
  * Thrust points...
  * Variable-size creatures...
  * "Fast" display mode...
  * 
  */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.io.*;
   import java.lang.Exception;
   import java.lang.Integer;
   import java.lang.Long;
   import java.lang.Object;
   import java.util.StringTokenizer;
   import java.util.Date;
   import java.awt.image.*;

   public class Shoals extends java.applet.Applet implements ActionListener, AdjustmentListener, ItemListener, Runnable {
      static int testing = 1;
      static int sample_rate = 64;
      static int use_native = 0;
   
      static TTMessage[] msgq;
   
      static TTChoice choose_resolution;
      static TTChoice choose_display;
      static TTChoice choose_kill;
      static TTChoice choose_start;
      static TTChoice choose_frequency;
      static TTChoice choose_mutation;
      static TTChoice choose_radiation;
      static TTChoice choose_delay;
      static TTChoice choose_sample_rate;
      static TTChoice choose_sample_number;
      static TTChoice choose_density;
      static TTChoice choose_quality;
   
      static int threadfinished;
      static int threadnowfinished;
   
      static int current_message = 0;
   
      static int finding_period;
   
      static int mouse_pressed = 0;
   
      static boolean show_exhaust = false;
      static boolean check_collisions = true;
   
      static int bit_density = 512; // divided by 1024
   
      static int period;
      static int a_atgrid = 0;
   
      static int paused = 0;
      static int stepping = 0;
   
      static int point_count_max = 67;
      static int point_count = 0;
   
      static int percentage_covered = 0;
      final static int CRITICAL_PERCENTAGE = 20;
   
      static int temp;
      static int temp2;
      static int last_temp;
      static int value;
   
      static int start_type;
   
      final static boolean crippled_version = true;
   
      final static Color colour_grey1 = new Color(0xB0B0B0);
   
      static boolean statusShown = true;
      private static volatile Thread recalc;
   
      final static int xoff = 4;
      final static int yoff = 4;
   
      static Font bold_font = new Font("Dialog", Font.BOLD, 12);
   
      static JUR rnd = new JUR();
      static Date HAL_date = new Date();
   
      static int cx;
      static int cy;
   
      static int x2;
      static int y2;
   
      static int bit;
   
      static int n0, s0, e0, w0;
      static int c0, c1;
   
      static int debug = 0;
   
      static int last_mousex;
      static int last_mousey;
   
      static long lastime = 0, newtime = 0, current_time;
   
      static int application = 0; //
   
      final static int MSGQ_SIZE = 32;
   
      static boolean oscd = false;
   
      // Java enumerations...
   
      // messages...
      final static int MSG_NULL          = 0;
      final static int MOUSE_CLICK       = 1;
      final static int MOUSE_DRAG        = 2;
      final static int MOUSE_ENTRY       = 3;
      final static int MSG_RESTART       = 4;
      final static int MSG_RESIZE        = 5;
      final static int MSG_CLEAR         = 6;
      final static int MSG_STEP          = 7;
      final static int MSG_PAUSE         = 8;
      final static int MSG_STOP          = 9;  // stop threads...
      final static int MSG_REVERSE       = 10;
      final static int MSG_SET           = 11;
      final static int MSG_RANDOMISE     = 12;
      final static int MSG_DENSITY_RESET = 13;
      final static int MSG_NEW_TYPE      = 14;
      final static int MSG_FREEZE        = 15;
      final static int MSG_MELT          = 16;
      final static int MSG_RECT          = 17;
      final static int MSG_HEX           = 18;
      final static int MSG_SOD           = 19;
      final static int MSG_WOLF          = 20;
      final static int MSG_NEW_CELLS     = 21;
      final static int MSG_CANCEL        = 22;
      final static int MSG_SETNEWSIZE    = 23;
      final static int MSG_PERIOD_FIND   = 24;
      final static int MSG_RESET_HISTORY = 25;
      final static int MSG_TRIUMPHANT    = 26;
      final static int MSG_CHANGE_AGENT_NUMBER = 27;
      final static int MSG_CHANGE_AGENT_NUMBER2 = 28;
      final static int MSG_DB            = 29;
   
      // resolutions
      final static int _RES_VHIGH  = 512;
      final static int _RES_HIGH   = 256;
      final static int _RES_MEDIUM = 128;
      final static int _RES_LOW    = 64;
      final static int _RES_VLOW   = 32;
      final static int _RES_TINY   = 16;
      final static int _RES_VTINY  = 8;
      final static int _RES_MINUTE = 4;
   
      final static int _CLEAR          = 0;
      final static int _SET            = 1;
      final static int _MAKEWALL       = 2;
      final static int _CLEARWALL      = 3;
      final static int _RANDOMISE      = 4;
      // final static int _MAKESINK       = 5;
      final static int _MAKESOURCE     = 5;
   
      final static int _PENCIL  = 0;
      final static int _BRUSH   = 1;
      final static int _MACHINE = 2;
      final static int _SPRAY   = 3;
      final static int _POTATO  = 4;
   
      final static int _FRAME_1  = 0;
      final static int _FRAME_2  = 1;
      final static int _FRAME_4  = 3;
      final static int _FRAME_8  = 7;
      final static int _FRAME_16 = 15;
      final static int _FRAME_32 = 31;
   
      final static int _DELAY_0   = 0;
      final static int _DELAY_1   = 1;
      final static int _DELAY_2   = 2;
      final static int _DELAY_5   = 5;
      final static int _DELAY_10  = 10;
      final static int _DELAY_20  = 20;
      final static int _DELAY_50  = 50;
      final static int _DELAY_100 = 100;
      final static int _DELAY_200 = 200;
      final static int _DELAY_512 = 512;
   
      final static int _SIMPLE    = 0;
      final static int _SIZES     = 1;
   
      final static int _QUALITY_0 = 0;
      final static int _QUALITY_1 = 1;
      final static int _QUALITY_2 = 2;
      final static int _QUALITY_3 = 3;
   
      static int quality = _QUALITY_2;
   
   	// strings...
      final static String RANDOMISE     = "Randomise";
      final static String CLEAR         = "Clear";
      final static String RESTART       = "Restart";
   
      final static String SETSIZE       = "Resize";
   
      final static String STEP          = "Step";
      final static String STEPPING      = "Stepping";
      final static String PAUSE         = "Paused";
      final static String CANCEL        = "Cancel";
      final static String PERIOD_FIND   = "Find period";
      final static String FINDINGPERIOD = "Finding period";
      final static String HISTORY_RESET = "Reset history";
      final static String DB            = "Double buffering";
      final static String EX            = "Show exhaust";
      final static String CC            = "Detect collisions";
      final static String OSCD          = "Use O(n^2) algorithm";
   
      final static String NATIVE        = "Test native generator";
   
      final static String REVERSE       = "Reverse";
      final static String DENSITY_SET   = "X";
   
      static String stateChangedString;
      // AWT
   
      // Panels
      static Panel panelA;
      static Panel panelA2;
      static Panel panelB;
      static Panel panelB2;
      static Panel panelC;
      static Panel panelD;
      static Panel panelE;
      static Panel panelF;
      static Panel panelG;
      static Panel panelG2;
      static Panel panelG3;
      static Panel panelG4;
      static Panel panelG5;
      static Panel panelG6;
      static Panel panelG7;
      static Panel panelH;
      static Panel panelI;
      static Panel panelJ;
      static Panel panelK;
      static Panel panelL;
      static Panel panel_randomise;
      static Panel panel_restart;
      static Panel panel_pause;
      static Panel panel_step;
      static Panel panel_step_size;
      static Panel panel_clear;
      static Panel panelP;
      static Panel panelQ;
      static Panel panelR;
      static Panel panelS;
      static Panel panelT;
      static Panel panelU;
      static Panel panelV;
      static Panel panelW;
      static Panel panelW2;
   
      static Panel panelX;
      static Panel panelY;
      static Panel panelZ;
   
      //AdjustmentListener adjustment_listener = new AdjustmentListener();
   
      static Scrollbar scroll_bar_n;
      static Scrollbar scroll_bar_n2;
      static Scrollbar scroll_bar_bias;
      static Scrollbar scroll_bar_friction;
      static Scrollbar scroll_bar_limit;
      static Scrollbar scroll_bar_accel;
      static Scrollbar scroll_bar_size;
      static Scrollbar scroll_bar_eggsize;
      static Scrollbar scroll_bar_gravity;
      static Scrollbar scroll_bar_like;
      static Scrollbar scroll_bar_piston;
   
      static Shoals_Canvas shoals_canvas;
   
      // buttons...
      static Button button_restart;
      static Button button_clear;
      static Button button_randomise;
      static Button button_set;
      static Button button_step;
      static Button button_setsize;
   
   
   	// checkboxes
      static Checkbox checkbox_pause;
   
      static Checkbox checkbox_simplesize;
      static Checkbox checkbox_complexsize;
      static Checkbox checkbox_db;
      static Checkbox checkbox_exhaust;
      static Checkbox checkbox_cc;
      static Checkbox checkbox_oscd;
   
   	// labels
      static Label label_show_gen;
      static Label label_show_time;
      static Label label_show_cells;
      static Label label_cell_count;
      static Label label_show_set;
      static Label label_resolution;
      static Label label_size_x;
      static Label label_size_y;
      static Label label_step_size;
      static Label label_history_size;
      static Label label_number;
      static Label label_number2;
      static Label label_bias;
      static Label label_friction;
      static Label label_limit;
      static Label label_size;
      static Label label_eggsize;
      static Label label_accel;
      static Label label_gravity;
      static Label label_like;
   
      // text fields
      static TextField textfield_size_x;
      static TextField textfield_size_y;
      static TextField textfield_step_size;
   
   	// colours
      static Color WorldColour    = Color.black;
      static Color GridColour     = Color.black;
      static Color PageColour     = Color.gray; // new Color(0xF0,0xE8,0xFF);
      static Color COLOUR_CIRCUIT = Color.black;
      static Color COLOUR_DIR     = Color.black;
   
      static Color[] colours;
   
      static int kill_type       = _SET;
   
      static int weapon_type     = _SPRAY;
   
      static int resolutionx;
      static int resolutiony;
   
      static int frame_frequency = _FRAME_1;
   
      static int delay           = _DELAY_0;
   
      static int busy = 0;
      static int old_busy_percentage = -1;
      static String busy_message;
   
   // ...........................Methods........................
      public void init() {
      }
   
   
      public void start() {
         resolutionx     = 144;
         resolutiony     = 110;
      
         Shoals_Grid.initialise(resolutionx,resolutiony);
      
         shoals_canvas = new Shoals_Canvas(this);
      
         Shoals_Grid.shoals_canvas = shoals_canvas;
      
         paused = 0;
         delay = 0;
      
         // Panels ADDED HERE
         panelX = new Panel();
         panelX.setLayout(new GridLayout(0,1,0,0));
         panelY = new Panel();
         panelZ = new Panel();
         panelZ.setLayout(new GridLayout(1,0,0,0));
      
         panelA = new Panel();
         panelA2 = new Panel();
         panelB = new Panel();
         panelB2 = new Panel();
         panelC = new Panel();
         panelD = new Panel();
         panelE = new Panel();
         panelF = new Panel();
         panelG = new Panel();
         panelG2 = new Panel();
         panelG3 = new Panel();
         panelG4 = new Panel();
         panelG5 = new Panel();
         panelG6 = new Panel();
         panelG7 = new Panel();
         panelH = new Panel();
         panelI = new Panel();
         panelJ = new Panel();
         panelK = new Panel();
         panelL = new Panel();
         panel_randomise     = new Panel();
         panel_restart       = new Panel();
         panel_pause         = new Panel();
         panel_step          = new Panel();
         panel_step_size     = new Panel();
         panel_clear         = new Panel();
         panelP = new Panel();
         panelQ = new Panel();
         panelR = new Panel();
         panelS = new Panel();
         panelT = new Panel();
         panelU = new Panel();
         panelV = new Panel();
         panelW = new Panel();
         panelW2 = new Panel();
      
         this.setBackground(Color.black);
      
         panelY.setBackground(PageColour);
         panelX.setBackground(Color.lightGray);
         panelZ.setBackground(Color.lightGray);
      
         choose_start = new TTChoice(this); //??? 
      
         // start with...
         panelA.setBackground(colour_grey1);
         panelA.setLayout(new BorderLayout(0,8));
         panelA.add("West",new Label("N:",Label.RIGHT));
      
         scroll_bar_n = new Scrollbar(Scrollbar.HORIZONTAL,EntityManager.target_number_of_agents,100,0,1100);
         scroll_bar_n.addAdjustmentListener(this); // adjustment_listener);
      
         panelA.add("Center",scroll_bar_n);
      
         label_number = new Label("" + EntityManager.target_number_of_agents,Label.LEFT);
         panelA.add("East",label_number);
      
         panelA2.setBackground(colour_grey1);
         panelA2.setLayout(new BorderLayout(0,8));
         panelA2.add("West",new Label("N(2):",Label.RIGHT));
      
         scroll_bar_n2 = new Scrollbar(Scrollbar.HORIZONTAL,EntityManager.target_number_of_leaders,100,0,1100);
         scroll_bar_n2.addAdjustmentListener(this); // adjustment_listener);
      
         panelA2.add("Center",scroll_bar_n2);
      
         label_number2 = new Label("" + EntityManager.target_number_of_leaders,Label.LEFT);
         panelA2.add("East",label_number2);
      
      	// weapon...
         // panelB.setBackground(colour_grey1);
         // panelB.add(new Label("Use",Label.RIGHT));
         checkbox_db = new Checkbox(DB);
         // checkbox_db.setState(true);
      
         checkbox_db.addItemListener(this);
      
         panelB.add(checkbox_db);
      
         panelB2.setBackground(colour_grey1);
         checkbox_oscd = new Checkbox(OSCD);
         checkbox_oscd.addItemListener(this);
      
         panelB2.add(checkbox_oscd);
      
      	// action...
         panelC.setLayout(new BorderLayout(0,8));
         panelC.add("West",new Label("Bias:",Label.RIGHT));
      
         scroll_bar_bias = new Scrollbar(Scrollbar.HORIZONTAL,0,90,-180,270);
         scroll_bar_bias.addAdjustmentListener(this);
      
         panelC.add("Center",scroll_bar_bias);
      
         label_bias = new Label("  0",Label.LEFT);
         panelC.add("East",label_bias);
      
         // piston
         panelP.setLayout(new BorderLayout(0,8));
         scroll_bar_piston = new Scrollbar(Scrollbar.VERTICAL,1000,50,0,1050);
         scroll_bar_piston.addAdjustmentListener(this);
      
         panelP.add("Center",scroll_bar_piston);
      
      //   label_bias = new Label("  0",Label.LEFT);
        // panelC.add("East",label_bias);
      
      	// display...
         checkbox_exhaust = new Checkbox(EX);
         // checkbox_exhaust.setState(true);
         checkbox_exhaust.addItemListener(this);
         panelD.add(checkbox_exhaust);
      
         panelE.setBackground(colour_grey1);
         checkbox_cc = new Checkbox(CC);
         checkbox_cc.setState(true);
         checkbox_cc.addItemListener(this);
         panelE.add(checkbox_cc);
      
         // choose_display = new TTChoice(this);
         //choose_display.add("snake-like" ,Shoals_Grid.SNAKELIKE);
         //choose_display.add("development",Shoals_Grid.DEVELOPMENT);
      
         //choose_display.add("main"       ,Shoals_Grid.HEADSANDCELLS);
         //choose_display.add("cell types" ,Shoals_Grid.CELLTYPES);
      
         //choose_display.choice.select(choose_display.num_to_str(Shoals_Grid.display_type));
         //panelD.add(choose_display.choice);
      
         CheckboxGroup checkbox_size_type = new CheckboxGroup();
      
         checkbox_simplesize = new Checkbox("" , checkbox_size_type, true);
         checkbox_simplesize.addItemListener(this);
      
         checkbox_complexsize = new Checkbox("" , checkbox_size_type, true);
         checkbox_complexsize.addItemListener(this);
      
         /*
      	choose_resolution = new TTChoice(this);
      
         label_resolution = new Label("Size:",Label.RIGHT);
         label_size_x = new Label("X:",Label.RIGHT);
         label_size_y = new Label("Y:",Label.RIGHT);
      
         textfield_size_x = new TextField("108",0); // max columns?
         textfield_size_y = new TextField("96",0); // max columns?
      
         button_setsize = new Button(SETSIZE);
         button_setsize.addActionListener(this);
      
         setUpResolutionSelector();
         setUpResolutionSelector2();
      	*/
      
      	// frame frequency...
         panelF.add(new Label("Show",Label.RIGHT));
      
         choose_frequency = new TTChoice(this);
         choose_frequency.add("every frame"       ,_FRAME_1);
         choose_frequency.add("every other frame" ,_FRAME_2);
         choose_frequency.add("one frame in four" ,_FRAME_4);
         choose_frequency.add("one frame in eight",_FRAME_8);
         choose_frequency.add("frames rarely"     , _FRAME_16);
         choose_frequency.add("very few frames"   ,_FRAME_32);
         choose_frequency.choice.select(choose_frequency.num_to_str(frame_frequency));
         panelF.add(choose_frequency.choice);
      
      	// frame frequency...
         // panelR.setBackground(colour_grey1);
         panelR.add(new Label("Delay:",Label.RIGHT));
         choose_delay = new TTChoice(this);
         choose_delay.add("0"     ,_DELAY_0);
         choose_delay.add("1"     ,_DELAY_1);
         choose_delay.add("2"     ,_DELAY_2);
         choose_delay.add("5"     ,_DELAY_5);
         choose_delay.add("10"    ,_DELAY_10);
         choose_delay.add("20"    ,_DELAY_20);
         choose_delay.add("50"    ,_DELAY_50);
         choose_delay.add("100"   ,_DELAY_100);
         choose_delay.add("200"   ,_DELAY_200);
         choose_delay.add("512"   ,_DELAY_512);
         choose_delay.choice.select(choose_delay.num_to_str(delay));
         panelR.add(choose_delay.choice);
      
         panelV.setBackground(colour_grey1);
         panelW.setBackground(colour_grey1);
         panelW2.setBackground(colour_grey1);
      
      	// friction.
         //panelG.setBackground(colour_grey1);
         panelG.setLayout(new BorderLayout(0,8));
         panelG.add("West",new Label("Friction:",Label.RIGHT));
      
         scroll_bar_friction = new Scrollbar(Scrollbar.HORIZONTAL,12,80,-100,600);
         scroll_bar_friction.addAdjustmentListener(this);
      
         panelG.add("Center",scroll_bar_friction);
      
         label_friction = new Label("12",Label.LEFT);
         panelG.add("East",label_friction);
      
         //limit
         panelG2.setBackground(colour_grey1);
         panelG2.setLayout(new BorderLayout(0,8));
         panelG2.add("West",new Label("Speed:",Label.RIGHT));
      
         scroll_bar_limit = new Scrollbar(Scrollbar.HORIZONTAL,Entity.max_velocity >> 5,0x40,0,0x100);
         scroll_bar_limit.addAdjustmentListener(this);
      
         panelG2.add("Center",scroll_bar_limit);
      
         label_limit = new Label("" + (Entity.max_velocity >> 5),Label.LEFT);
         panelG2.add("East",label_limit);
      
         // accel
         panelG3.setBackground(colour_grey1);
         panelG3.setLayout(new BorderLayout(0,8));
         panelG3.add("West",new Label("Acc:",Label.RIGHT));
      
         scroll_bar_accel = new Scrollbar(Scrollbar.HORIZONTAL,0x40,0x100,0,0x500);
         scroll_bar_accel.addAdjustmentListener(this);
      
         panelG3.add("Center",scroll_bar_accel);
      
         label_accel = new Label("64",Label.LEFT);
         panelG3.add("East",label_accel);
      
         // size
         panelG4.setLayout(new BorderLayout(0,8));
         panelG4.add("West",new Label("Size:",Label.RIGHT));
      
         scroll_bar_size = new Scrollbar(Scrollbar.HORIZONTAL,20,20,2,70);
         scroll_bar_size.addAdjustmentListener(this);
         panelG4.add("Center",scroll_bar_size);
      
         label_size = new Label("20",Label.LEFT);
         panelG4.add("East",label_size);
      
         // eggsize
         // panelG5.setBackground(colour_grey1);
         panelG5.setLayout(new BorderLayout(0,8));
         panelG5.add("West",new Label("Size(2):",Label.RIGHT));
      
         scroll_bar_eggsize = new Scrollbar(Scrollbar.HORIZONTAL,100,60,2,500);
         scroll_bar_eggsize.addAdjustmentListener(this);
      
         panelG5.add("Center",scroll_bar_eggsize);
      
         label_eggsize = new Label("60",Label.LEFT);
         panelG5.add("East",label_eggsize);
      
         // gravity
         panelG6.setBackground(colour_grey1);
         panelG6.setLayout(new BorderLayout(0,8));
         panelG6.add("West",new Label("Gravity:",Label.RIGHT));
      
         scroll_bar_gravity = new Scrollbar(Scrollbar.HORIZONTAL,10,80,0,580);
         scroll_bar_gravity.addAdjustmentListener(this);
      
         panelG6.add("Center",scroll_bar_gravity);
      
         label_gravity = new Label("100",Label.LEFT);
         panelG6.add("East",label_gravity);
      
         // pointer affinity
         panelG7.setBackground(colour_grey1);
         panelG7.setLayout(new BorderLayout(0,8));
         panelG7.add("West",new Label("Follow:",Label.RIGHT));
      
         scroll_bar_like = new Scrollbar(Scrollbar.HORIZONTAL,0xC0,100,0,1100);
         scroll_bar_like.addAdjustmentListener(this);
      
         panelG7.add("Center",scroll_bar_like);
      
         label_like = new Label("192",Label.LEFT);
         panelG7.add("East",label_like);
      
         panelH.setBackground(colour_grey1);
         panelH.add(new Label("Quality:",Label.RIGHT));
      
         choose_quality = new TTChoice(this);
         choose_quality.add("best"     ,_QUALITY_0);
         choose_quality.add("medium"   ,_QUALITY_1);
         choose_quality.add("poor"     ,_QUALITY_2);
         choose_quality.add("abysmal"  ,_QUALITY_3);
         choose_quality.choice.select(choose_quality.num_to_str(quality));
         panelH.add(choose_quality.choice);
      
         // panelK.setBackground(colour_grey1);
         panelK.add(new Label("Generation:",Label.RIGHT));
         label_show_gen = new Label("0       ",Label.LEFT);
         panelK.add(label_show_gen);
      
         // panelL.setBackground(colour_grey1);
         panelL.add(new Label("Time/gen:",Label.RIGHT));
         label_show_time = new Label("0  ",Label.LEFT);
         panelL.add(label_show_time);
      
         //panelP.add(new Label("Set proportion:",Label.RIGHT));
         //label_show_set = new Label("0.000000000",Label.LEFT);
         //panelP.add(label_show_set);
      
         label_step_size = new Label("Step size:",Label.RIGHT);
      
         textfield_step_size = new TextField("1",0); // max columns?
         panel_step_size.add(label_step_size);
         panel_step_size.add(textfield_step_size);
      
         // Step...
         // 
         // panel_pause.setBackground(colour_grey1);
         button_step = new Button(STEP);
         button_step.addActionListener(this);
         button_step.setFont(bold_font);
         panel_step.setLayout(new BorderLayout(0,0));
         panel_step.add(button_step);
      
      	// pause...
         checkbox_pause = new Checkbox(PAUSE);
         checkbox_pause.addItemListener(this);
      	// panel_pause.setLayout(new BorderLayout(0,0));
         panel_pause.add(checkbox_pause);
      
         /*panel_randomise.setBackground(colour_grey1);
         // randomise...
         button_randomise = new Button(RANDOMISE);
         button_randomise.addActionListener(this);
         button_randomise.setFont(bold_font);
         button_randomise.setForeground(Color.red);
         panel_randomise.setLayout(new BorderLayout(0,0));
         panel_randomise.add(button_randomise);*/
      
      	// restart
         button_restart = new Button(RESTART);
         button_restart.addActionListener(this);
         button_restart.setFont(bold_font);
         button_restart.setForeground(Color.red);
         panel_restart.setLayout(new BorderLayout(0,0));
         panel_restart.add(button_restart);
      
      	// clear
         /*button_clear = new Button(CLEAR);
         button_clear.addActionListener(this);
         button_clear.setFont(bold_font);
         button_clear.setForeground(Color.red);
         panel_clear.setLayout(new BorderLayout(0,0));
         panel_clear.add(button_clear);*/
      
         setLayout(new BorderLayout(0,0));
      
         add("South",panelZ);
      
         add("East",panelX);
         add("West",panelP);
         add("Center",(Canvas)shoals_canvas);
      
         panelX.add(panelA);
         panelX.add(panelA2);
         panelX.add(panelG4);
         panelX.add(panelG5);
         // panelX.add(panelC);
      
         //panelX.add(panelQ);
      
      
         panelX.add(panelG2);
         panelX.add(panelG);
         // panelX.add(panelG3); // acc
      
         panelX.add(panelG6);
         // panelX.add(panelG7); //follow
      
         panelX.add(panelF); // show:
      
         panelX.add(panelH); // quality
         panelX.add(panelR);
         // panelX.add(panelD);
         panelX.add(panelE);
         panelX.add(panelB2); // OSCD
         panelX.add(panelB); // DB
      
         panelZ.add(panelK);
         panelZ.add(panelL);
      
         panelZ.add(panel_step_size);
         panelZ.add(panel_step);
         panelZ.add(panel_pause);
      
         // panelZ.add(panel_clear);
         //panelZ.add(panel_randomise);
         panelZ.add(panel_restart);
      
      
         grey_selected_one();
         grey_selected_two();
      
         msgq = new TTMessage[MSGQ_SIZE];
      
         for (int c = 0; c < MSGQ_SIZE; c++) {
            msgq[c] = new TTMessage(0,0,0);
         }
      
         ordered_start();
      
         shoals_canvas.start_up();
      
         recalc = new Thread(this);
      
         recalc.start();
      
         if (application != 0) {
            resize(320,512);
         }
      }
   
   
      public static void setUpResolutionSelector() {
        /* panelE.removeAll();
      
         choose_resolution.removeAll();
      
         panelE.setBackground(colour_grey1);
      
         panelE.add(label_resolution);
      
         String appendedstring = "(x3)";
      
         choose_resolution.add("8x8 "     + appendedstring ,_RES_VTINY);
         choose_resolution.add("16x16 "   + appendedstring ,_RES_TINY);
         choose_resolution.add("32x32 "   + appendedstring ,_RES_VLOW);
         choose_resolution.add("64x64 "   + appendedstring ,_RES_LOW);
         choose_resolution.add("128x128 " + appendedstring ,_RES_MEDIUM);
         choose_resolution.add("256x256 " + appendedstring ,_RES_HIGH);
      // temp = 
         choose_resolution.choice.select(choose_resolution.num_to_str(32)); // if possible...?
         choose_resolution.choice.select(choose_resolution.num_to_str(resolutionx)); // if possible...?
      
         panelE.add(choose_resolution.choice); */
      }
   
   
      public static void setUpResolutionSelector2() {
         panelQ.removeAll();
         panelQ.setBackground(colour_grey1);
         panelQ.add(label_size_x);
         panelQ.add(textfield_size_x);
         panelQ.add(label_size_y);
         panelQ.add(textfield_size_y);
      
         panelQ.add(button_setsize);
      }
   
   
      public static void random_start() {
      		/*
         clearStateBits();
      
         for (cx = Shoals_Grid.hside; cx-- > 0; ) {
            for (cy = Shoals_Grid.vside; cy-- > 0; ) {
               if ((rnd.nextInt() & 1023) < 300) {
                  Shoals_Grid.in_grid[cx][cy] = Shoals_Grid.DEAD;
               }
               else
               {
                  Shoals_Grid.in_grid[cx][cy] = Shoals_Grid.randomCell();
               }
            }
         }
      	*/
      }
   
   
      public static void ordered_start() {
         // clearStateBits();
         Shoals_Grid.RepaintAll = true;
      
         // init_loop();
      }
   
   
   /*
      public static void init_loop() {
         switch (start_type) {
            case _SIMPLE:
               make_loop(100,600,1,"ACCCCCCCCCBBBBBBBBBD");
               make_loop(300,300,1,"ACCCBCCCBCCCBCCCBCCCD");
               make_loop(500,450,1,"ABCBCBCBCBCBCBCBCBCD");
               make_loop(700,300,1,"ABBBCBBBCBBBCBBBCBBBD");
               make_loop(900,600,1,"ABBBBBBBBBCCCCCCCCCD");
            
               break;
         
            case _SIZES:
               make_loop(100,300,1,"ABD");
               make_loop(200,350,1,"ACBCD");
               make_loop(300,400,1,"ABBCBBD");
               make_loop(400,450,1,"ACCCBCCCD");
               make_loop(500,500,1,"ABBBBCBBBBD");
               make_loop(600,550,1,"ACCCCCBCCCCCD");
               make_loop(700,600,1,"ABBBBBBCBBBBBBD");
               make_loop(800,650,1,"ACCCCCCCBCCCCCCCD");
               make_loop(900,700,1,"ABBBBBBBBCBBBBBBBBD");
            
               break;
         }
      
         Shoals_Grid.RepaintAll = true;
      }
   */
   
   /*
      public static void make_loop(int not, String instruct) {
         make_loop(rnd.nextInt(),rnd.nextInt(),not,instruct);
      }
   
   
      private static String preprocess(String instruct, int not) {
         String newstring = "";
         int temp = 0;
         int len = instruct.length();
         char c;
      
         while (temp < len) {
         
            c = instruct.charAt(temp++);
            if (c > '9')
               newstring = newstring + c;
            else
            {
               temp2 = (c) - '0';
               if (temp2 < 3)
                  temp2 += 10;
               c = instruct.charAt(temp++);
               for (last_temp = 0; last_temp < temp2; last_temp++) {
                  newstring = newstring + c;
               }
            }
         }
      
         if (not >= 2)
            newstring += newstring;
         if (not == 4)
            newstring += newstring;
      
         return newstring;
      }
   
   
      public static void make_loop(int x, int y, int not, String instruct) {
         int a;
         // int dir = Shoals_Grid.SOUTH;
         int loi;
         int nv = 0;
         int n2 = 0;
      
         int cx = 0;
         int cy = 0;
      
         int c;
         int talker = 0;
      
         instruct = preprocess(instruct, not);
      
         cx = (x * (Shoals_Grid.hside)) >>> 10;
         cy = (y * (Shoals_Grid.vside)) >>> 10;
      
         loi = instruct.length();
         for (a = 0; a < loi; a++) {
         
            c = ((int)instruct.charAt(a)) - 64;
            nv = c;
         
            temp = ((int)instruct.charAt(loi - a - 1)) - 64;
         
            if ((cx >= 0) && (cx < Shoals_Grid.hside) && (cy >= 0) && (cy < Shoals_Grid.vside)) {
               Shoals_Grid.in_grid[cx][cy] = c; //  | (Shoals_Grid.reproduction_delay_min << 16);
            }
         
            cy++;
         }
      }
   */
   
      public static void probablyDecrementx() {
         if ((cy & 1) != 0) {
            cx--;
         }
      }
   
   
      public static void clearAll() {
      }
   
   
      public static void clearStateBits() {
      		/*
         for (cx = Shoals_Grid.hside; cx-- > 0; ) {
            for (cy = Shoals_Grid.vside; cy-- > 0; ) {
               Shoals_Grid.in_grid[cx][cy] &= 0xffffff00;
            }
         }
      	*/
      }
   
   
      // .....................Run Method......................
      final public void run() {
         // System.out.println("90:" + Integer.toHexString(90) + " - 150: "+ Integer.toHexString(150));
      
         threadfinished = 0;
         threadnowfinished = 0;
      
         while (threadfinished == 0) {
            if (paused == 0) {
               Shoals_Grid.generation += Shoals_Grid.direction;
            
               Shoals_Grid.calculate_grid();
            
               if (stepping > 0) {
                  if (--stepping == 0) {
                     endStepping();
                  }
               }
            }
         
            if (Shoals_Grid.double_buffering) {
               if (current_message != 0)
                  handlemessages();
            
            // if (frame_frequency <= 16) {
            
               Shoals_Grid.redraw_changed(Shoals_Canvas.image_handle);
            }
            // }
         
            if ((((Shoals_Grid.generation) & frame_frequency) == 0) || (paused != 0)) {
               //if (frame_frequency > 16) {
                  //if (Shoals_Grid.double_buffering) {
                     //Shoals_Grid.redraw_changed(Shoals_Canvas.image_handle);
                 // }
               //}
            
               shoals_canvas.repaint();
            
               if (delay > 0) {
                  try {
                     recalc.sleep((long) delay);
                  } 
                     catch (InterruptedException e) {
                     }
               }
            
               updateStatus();
            
               recalc.yield();
            }
         }
      
         threadnowfinished = 1;
      
         recalc.yield();
      }
   
   
      final public static void endStepping() {
         stepping = 0;
         paused = 1;
         grey_selected_three();
         button_step.setLabel(STEP);
      }
   
      final public void stop() {
         newmessage(MSG_STOP,0,0);
      
         recalc.yield();
      
         while (threadnowfinished == 0) {
            System.out.print("Apologies! ");
            recalc.yield();
         }
      
         this.removeAll();
      }
   
   
      final static private void updateStatus() {
         label_show_gen.setText("" + (Shoals_Grid.generation));
      
         if (frame_frequency < 14)
            temp = 15;
         else 
            temp = frame_frequency;
      
         if (((Shoals_Grid.generation) & temp) == 0) {
            newtime = System.currentTimeMillis();
            label_show_time.setText("" + ((newtime - lastime) / (temp + 1)));
            lastime = newtime;
         }
      }
   
   
      final static void handlemessages() {
         int msgn = 0;
      
         for (msgn = 0; msgn < current_message; msgn++) {
            switch (msgq[msgn].type) {
               case MOUSE_DRAG:
                  HAL_mouseDragged(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MOUSE_CLICK:
                  HAL_mouseClicked(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MOUSE_ENTRY:
                  HAL_mouseEntered(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MSG_RESTART:
                  // clearAllWalls();
                  ordered_start();
                  Shoals_Grid.newboids();
                  redrawIfPaused();
               
                  break;
            
               case MSG_RANDOMISE:
                  random_start();
                  redrawIfPaused();
               
                  break;
            
               case MSG_CLEAR:
                  Shoals_Grid.resetGrid();
                  redrawIfPaused();
               
                  break;
            
               case MSG_RESIZE:
                  resolutionx = msgq[msgn].data1;
                  resolutiony = resolutionx;
                  performResize();
               
                  break;
            
               case MSG_SETNEWSIZE:
                  try {
                     resolutionx = Integer.parseInt(textfield_size_x.getText());
                  } 
                     catch (Exception e) {
                        resolutionx = 32;
                     }
               
                  try {
                     resolutiony = Integer.parseInt(textfield_size_y.getText());
                  } 
                     catch (Exception e) {
                        resolutiony = 32;
                     }
               
                  performResize();
               
                  break;
            
               case MSG_STEP:
                  paused = 0;
               
                  try {
                     stepping = Integer.parseInt(textfield_step_size.getText());
                  } 
                     catch (Exception e) {
                        stepping = 1;
                     }
               
                  grey_selected_three();
                  button_step.setLabel(CANCEL);
               
                  break;
            
               case MSG_STOP:
                  threadfinished = 1;
               
                  break;
            
               case MSG_CHANGE_AGENT_NUMBER:
                  EntityManager.target_number_of_agents = msgq[msgn].data1;
                  EntityManager.changeNumber();
               
                  label_number.setText("" + EntityManager.target_number_of_agents);
                  Shoals_Grid.RepaintAll = true;
               
                  break;
            
               case MSG_CHANGE_AGENT_NUMBER2:
                  EntityManager.target_number_of_leaders = msgq[msgn].data1;
                  EntityManager.changeLeaderNumber();
               
                  label_number2.setText("" + EntityManager.target_number_of_leaders);
                  Shoals_Grid.RepaintAll = true;
               
                  break;
            
               case MSG_DB:
                  Shoals_Grid.double_buffering = !Shoals_Grid.double_buffering;
                  Shoals_Grid.RepaintAll = true;
                  Shoals_Canvas.getImageHandle();
                  Shoals_Canvas.forceResize(); // gsx_old = -1; // force resize...
               
                  break;
            
               case MSG_PAUSE:
                  paused = paused ^ 1;
                  grey_selected_two();
               
                  break;
            
               case MSG_CANCEL:
                  endStepping();
               
                  break;
            }
         }
      
         current_message = 0;
      
         if (mouse_pressed != 0)
            newmessage(MOUSE_CLICK,last_mousex,last_mousey);
      }
   
   
      final static public void performResize() {
         Shoals_Canvas.forceResize();
         Shoals_Grid.set_size(resolutionx,resolutiony);
         ordered_start();
         // setUpCellTypes();
         // setUpShoals_Points();
      }
   
   
      final static public void newmessage(int t, int d1, int d2) {
         if (current_message < MSGQ_SIZE) {
            msgq[current_message].type = t;
            msgq[current_message].data1 = d1;
            msgq[current_message].data2 = d2;
         
            current_message++;
         }
      }
   
   
      public void adjustmentValueChanged(AdjustmentEvent e) {
         //Shoals_Grid.number_of_agents = e.getValue();
         if (e.getSource() == scroll_bar_n) {
            newmessage(MSG_CHANGE_AGENT_NUMBER,e.getValue(),0);
         }
      
         if (e.getSource() == scroll_bar_n2) {
            newmessage(MSG_CHANGE_AGENT_NUMBER2,e.getValue(),0);
         }
      
         if (e.getSource() == scroll_bar_bias) {
            temp = e.getValue();
            Entity.direction_bias = (temp * 16) / 180;
            label_bias.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_piston) {
            temp = e.getValue();
            EntityManager.piston = temp;
            Shoals_Grid.RepaintAll = true;
            Shoals_Grid.virgin_applet = 1;
         }
      
         if (e.getSource() == scroll_bar_friction) {
            temp = e.getValue();
            Entity.friction_strength = temp;
            label_friction.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_limit) {
            temp = e.getValue();
            Entity.max_velocity = temp << 5;
            label_limit.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_size) {
            temp = e.getValue();
            EntityManager.setGlobalSize(temp);
            label_size.setText("" + temp);
            // Shoals_Grid.newboids();
            EntityManager.resetEntityGrid();
         
            Shoals_Grid.RepaintAll = true;
         }
      
         if (e.getSource() == scroll_bar_eggsize) {
            temp = e.getValue();
            EntityManager.setGlobalEggSize(temp);
            label_eggsize.setText("" + temp);
            EntityManager.resetEntityGrid();
            // Shoals_Grid.newboids();
         
            Shoals_Grid.RepaintAll = true;
         }
      
         if (e.getSource() == scroll_bar_gravity) {
            temp = e.getValue();
            EntityManager.gravity = temp;
            label_gravity.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_like) {
            temp = e.getValue();
            EntityManager.acc_of_leader = temp;
            label_like.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_accel) {
            temp = e.getValue();
            EntityManager.towards_leader = temp << 8;
            label_accel.setText("" + temp);
         }
      }
   
      public void itemStateChanged(ItemEvent e) {
         if (e != null) {
            stateChangedString = (String)(e.getItem());
         }
      
         // action
         //if (choose_kill.str_to_num(stateChangedString) != -99) {
            //kill_type = choose_kill.str_to_num(stateChangedString);
         //}
      
         //if (choose_start.str_to_num(stateChangedString) != -99) {
            //start_type = choose_start.str_to_num(stateChangedString);
            //newmessage(MSG_RESTART,0,0);
         //}
      
         // weapon...
         //if (choose_tool.str_to_num(stateChangedString) != -99) {
           // weapon_type = choose_tool.str_to_num(stateChangedString);
         //}
      
         // show
         //if (choose_display.str_to_num(stateChangedString) != -99) {
            //Shoals_Grid.display_type = choose_display.str_to_num(stateChangedString);
            //Shoals_Grid.smear_y = 0;
            //Shoals_Grid.RepaintAll = true;
         //}
      
         // restart
         if (choose_start.str_to_num(stateChangedString) != -99) {
            // HAL_Grid.start_type = choose_start.str_to_num(stateChangedString);
            newmessage(MSG_NEW_TYPE,0,0);
         }
      
         // res
         /*
         if (choose_resolution.str_to_num(stateChangedString) != -99) {
            temp = choose_resolution.str_to_num(stateChangedString);
            newmessage(MSG_RESIZE,temp,0);
         }
      	*/
      
         // frame frequency...
         if (choose_frequency.str_to_num(stateChangedString) != -99) {
            frame_frequency = choose_frequency.str_to_num(stateChangedString);
            Shoals_Grid.RepaintAll = true;
         }
      
      	// mutation rate...
         //if (choose_mutation.str_to_num(stateChangedString) != -99) {
          //  Shoals_Grid.mutation_rate = choose_mutation.str_to_num(stateChangedString);
         //}
      
      // radiation rate...
         //if (choose_radiation.str_to_num(stateChangedString) != -99) {
         //   Shoals_Grid.radiation_rate = choose_radiation.str_to_num(stateChangedString);
         //}
      
         //  delay selection...
         if (choose_delay.str_to_num(stateChangedString) != -99) {
            delay = choose_delay.str_to_num(stateChangedString);
         }
      
      	// quality selection...
         if (choose_quality.str_to_num(stateChangedString) != -99) {
            quality = choose_quality.str_to_num(stateChangedString);
            Shoals_Grid.RepaintAll = true;
         }
      
         // pause?
         if (e.getSource() == checkbox_pause) { // stateChangedString.equals(PAUSE)) {
            newmessage(MSG_PAUSE,0,0);
         }
      
      	// double buff
         if (stateChangedString.equals(DB)) {
            newmessage(MSG_DB,0,0);
         }
      
      	// double oscd
         if (stateChangedString.equals(OSCD)) {
            oscd = !oscd;
            // newmessage(MSG_OSCD,0,0);
         }
      
      
      	// pause?
         if (stateChangedString.equals(EX)) {
            show_exhaust = !show_exhaust;
            Shoals_Grid.RepaintAll = true;
         }
      
         if (stateChangedString.equals(CC)) {
            check_collisions = !check_collisions;
         }
      }
   
   
      public void actionPerformed(ActionEvent e) {
         String arg = e.getActionCommand();
         Object source = e.getSource();
      
         if (arg.equals(RESTART)) {
            newmessage(MSG_RESTART,0,0);
         }
         
         else if (arg.equals(RANDOMISE)) {
            newmessage(MSG_RANDOMISE,0,0);
         }
         
         else if (arg.equals(CLEAR)) {
            newmessage(MSG_CLEAR,0,0);
         }
         
         else if (arg.equals(STEP)) {
            newmessage(MSG_STEP,0,0);
         }
         
         else if (arg.equals(SETSIZE)) {
            newmessage(MSG_SETNEWSIZE,0,0);
         }
         
         else if (arg.equals(CANCEL)) {
            newmessage(MSG_CANCEL,0,0);
         }
      }
   
   
      public static void grey_selected_one() {
      }
   
   
      public static void grey_selected_two() {
      
         boolean flag = (paused != 0) ? true : false;
         button_step.setEnabled(flag);
      }
   
   
      public static void grey_selected_three() {
         boolean flag = (paused != 0) ? true : false;
      
         checkbox_pause.setEnabled(flag);
         button_restart.setEnabled(flag);
         // button_clear.setEnabled(flag);
         // button_randomise.setEnabled(flag);
      }
   
   
      public static void grey_selected_four() {
      
      }
   
   
      private static final void kill_a_line(int x, int y, int ox, int oy) {
         float _x = x;
         float _y = y;
         float dx, dy;
         float dis;
         float num;
      
         switch (weapon_type) {
            case _MACHINE:
               temp = 16;
               break;
         
            case _BRUSH:
               temp = 4;
               break;
         
            case _SPRAY:
               temp = 8;
               break;
         
            case _POTATO:
               temp = 12;
               break;
         
            default:
               temp = 1;
         }
      
         dis = (int) (Math.sqrt((double)(((x - ox) * (x - ox)) + ((y - oy) * (y - oy))))) + 2;
      
         if (dis <= temp) {
            num = dis + 2;
         }
         else
         {
            num = (float)(dis / (float)temp);
         }
      
         if (num < 2)
            num = 2;
      
         //num = dis;
         //temp = 1;
      
         dx = (float)((ox - x) / num);
         dy = (float)((oy - y) / num);
      
         for (int i = 0; i < (int)num; i++) {
            single_killing((int)_x,(int)_y);
            _x += dx;
            _y += dy;
         }
      }
   
   
      private static final void kill_a_cell(int x, int y) {
         x2 = (x >>> 1) % Shoals_Grid.hside;
         y2 = (y >>> 1) % Shoals_Grid.vside;
      
         bit = 255;
      
         switch (kill_type) {
            case _RANDOMISE:
            
            
               break;
         
            case _CLEAR:
            
            
               break;
         
            case _SET:
            
               break;
         
            case _MAKEWALL:
            
               break;
         
            //case _MAKESINK:
               //Shoals_Grid.in_grid[x2][y2] = Shoals_Grid.SINK;
         
               //break;
         
            case _MAKESOURCE:
            
               break;
         
            case _CLEARWALL:
            
            
               break;
         
         }
      }
   
      public static void HAL_mouseDragged(int x,int y) {
         kill_a_line(x, y, last_mousex, last_mousey);
      
         last_mousex = x;
         last_mousey = y;
      
         // redrawIfPaused();
      }
   
   
      public static void HAL_mouseClicked(int x,int y) {
         single_killing(x,y);
      
         last_mousex = x;
         last_mousey = y;
      
         // redrawIfPaused();
      }
   
   
      public static void redrawIfPaused() {
         // if (paused != 0) 
            // Shoals_Grid.RepaintAll = true;
      }
   
   
      public static void single_killing(int x,int y) {
         if ((x >= 0) && (y >= 0) && ((x >> 1) < Shoals_Grid.hside) && ((y >> 1) < Shoals_Grid.vside)) {
            switch (weapon_type) {
               case _PENCIL:
                  kill_a_cell(x, y);
                  break;
            
               case _BRUSH:
                  circle_fill(x,y,8,0);
                  break;
            
               case _MACHINE:
                  octagon_fill(x,y,20,31);
                  break;
            
               case _SPRAY:
                  octagon_fill(x,y,10,7);
                  break;
            
               case _POTATO:
                  circle_fill(x,y,16,0);
                  break;
            }
         }
      }
   
   
      public static void octagon_fill(int x, int y, int r, int f) {
         for (cx = -r; cx < r; cx++) {
            for (cy = -r; cy < r; cy++) {
               if ((rnd.nextInt() & f) == 0)
                  if (((cx + cy) > (r *-1.5)) && ((cx + cy) < (r*1.5)) && ((cx - cy) > (r *-1.5)) && ((cx - cy) < (r*1.5)))
                     // if (Shoals_Grid.edge_enforcement != 0) {
                     if ((x+cx >= 0) && (((x + cx) >>> 1) < Shoals_Grid.hside) && (y + cy >= 0) && (((y + cy) >>> 1) < Shoals_Grid.vside))
                        kill_a_cell(x + cx, y + cy);
                     //}
                     //else
                     //{
                        //kill_a_cell(x + cx, y + cy);
                     //}
            }
         }
      }
   
   
      public static void circle_fill(int x, int y, int r, int f) {
         for (cx = -r; cx < r; cx++) {
            for (cy = -r; cy < r; cy++) {
               if ((rnd.nextInt() & f) == 0)
                  if ((cx*cx + cy* cy) < r*r) 
                  // if (((cx + cy) > (r *-1.5)) && ((cx + cy) < (r*1.5)) && ((cx - cy) > (r *-1.5)) && ((cx - cy) < (r*1.5)))
                     //if (Shoals_Grid.edge_enforcement != 0) {
                     if ((x+cx >= 0) && (((x + cx) >>> 1) < Shoals_Grid.hside) && (y+cy >= 0) && (((y + cy) >>> 1) < Shoals_Grid.vside))
                        kill_a_cell(x + cx, y + cy);
                     //}
                     //else
                     //{
                        //kill_a_cell(x + cx, y + cy);
                     //}
            }
         }
      }
   
   
      public static void HAL_mouseEntered(int x,int y) {
         last_mousex = x;
         last_mousey = y;
      }
   
   
      public static void nowBusy(String message) {
         busy = 1;
         busy_message = message;
      	// busy_percentage = -1;
         old_busy_percentage = 0;
      
         cx = Shoals_Grid.hside * Shoals_Grid.gridsize;
         cy = Shoals_Grid.vside * Shoals_Grid.gridsize;
      
         int t = cx / 20;
         if (t < 10) 
            t = 10;
      
         if (Shoals_Canvas.image_handle != null) {
            Shoals_Canvas.image_handle.setColor(Color.black);
            Shoals_Canvas.image_handle.fillRect(0,0,9999,9999);
         
            Shoals_Canvas.image_handle.setFont(new Font("Helvetica", Font.BOLD, t));
         
            Shoals_Canvas.image_handle.setColor(Color.white);
            Shoals_Canvas.image_handle.drawString(Shoals.busy_message, (cx / 2) - (t * 4), (cy * 1) / 8);
            Shoals_Canvas.image_handle.drawString("Please be patient", (cx / 2) - (t * 4), (cy * 2) / 8);
         
            Shoals_Canvas.image_handle.drawRect(0, cy * 8/16, cx - 1, cy / 16);
         }
      
         shoals_canvas.repaint();
      }
   
   
      public static void notBusy() {
      /*
         busy = 0;
      
         Shoals_Grid.RepaintAll = true;
      
         shoals_canvas.repaint();
      */
      }
   
   
      public static void percentageBusy(int p) {
         cx = Shoals_Grid.hside * Shoals_Grid.gridsize;
         cy = Shoals_Grid.vside * Shoals_Grid.gridsize;
      
         int t = (Shoals_Grid.hside * Shoals_Grid.gridsize) / 13;
      
         if (t < 10) 
            t = 10;
      
         if (Shoals_Canvas.image_handle != null) {
            Shoals_Canvas.image_handle.setFont(new Font("Helvetica", Font.BOLD, t));
         
            Shoals_Canvas.image_handle.setColor(Color.black);
            Shoals_Canvas.image_handle.fillRect(cx * 2 / 5, (cy * 5) / 16, cx / 5, cy / 12);
         
            Shoals_Canvas.image_handle.setColor(Color.white);
            Shoals_Canvas.image_handle.drawString("" + p + "%", (cx / 2) - (t * 1), (cy * 3) / 8);
         
            temp = 3 + (((p - old_busy_percentage) * cx ) / 100);
            temp2 = 3 + (cx * old_busy_percentage) / 100;
            if (p == 100) {
               temp2 = cx - 3 - temp;
            }
         
            Shoals_Canvas.image_handle.setColor(Color.red);
            Shoals_Canvas.image_handle.fillRect(temp2, ((cy * 8) / 16) + 3, temp, (cy / 16) - 4);
         }
      
         old_busy_percentage = p;
      
         shoals_canvas.repaint();
      }
   
   
      // main method
      public static void main(String args[]) {
         Shoals applet = new Shoals();
      
         Shoals.application = 1;
      
         Frame frame = new TTAppletFrame("Shoals",(Applet)applet,760,640);
      }
   
   
      public String getAppletInfo() {
         return "Shoals - self-reproducting cellular automata.";
      }
   
   }
